/* Colors */

/* Generic */
$black: rgb(0,0,0);
$white: rgb(255,255,255);
$red: rgb(255,0,0);
$green: rgb(0,255,0);
$blue: rgb(0,0,255);
$transparent: rgba(0,0,0,0);

/* Theme */
$c-primary: $primary;
$c-secondary: $secondary;

/*$c-mono--black: rgb(0,0,0);
$c-mono--darkest: rgb(30,30,30);
$c-mono--dark: rgb(60,60,60);
$c-mono--median: rgb(100,100,100);
$c-mono--light: rgb(150,150,150);
$c-mono--lightest: rgb(200,200,200);
$c-mono--almostwhite: rgb(240,240,240);
$c-mono--white: rgb(255,255,255);*/

$colors: (
    transparent: transparent,
    theme-primary: $c-primary,
    theme-secondary: $c-secondary,
    theme-third-lightest: #E0E7F4,
    theme-fourth: #50357E,
    mono-black: rgb(0,0,0),
    mono-darkest: rgb(30,30,30),
    mono-dark: rgb(60,60,60),
    mono-median: rgb(100,100,100),
    mono-light: rgb(150,150,150),
    mono-lightest: rgb(200,200,200),
    mono-almostwhite: rgb(240,240,240),
    mono-white: rgb(255,255,255),
);

/* Color Utilities */

:root {
    @each $color-name, $color-value in $colors {
      --c-#{$color-name}: #{$color-value};
    }
}

@each $color-name, $color-value in $colors {
    .c-#{$color-name} {
        color: var(--c-#{$color-name}, $color-value);
    }
    .bg-#{$color-name} {
        background-color: var(--c-#{$color-name}, $color-value);
    }
    .ol-#{$color-name} {
        -webkit-text-stroke: 1px var(--c-#{$color-name}, $color-value);
        text-stroke: 1px var(--c-#{$color-name}, $color-value);
    }
    .bc-#{$color-name} {
        border-color: $color-value;
    }
}

@function color($color) {
    @return map-get($colors, $color);
}

body {
    background: color(theme-third-lightest);
    color: color(mono-darkest);
    &.dark-mode {
        background: color(mono-darkest);
        color: color(mono-almostwhite);
    }
}

::selection {
    color: color(mono-black);
    background-color: color(mono-lightest);
    body.dark-mode & {
        color: color(theme-third-lightest);
        background-color: color(mono-darkest);
    }
    a {
        color: color(theme-fourth);
        body.dark-mode & {
            color: color(theme-primary);
        }
    }
}
body:has(.dark-mode) {

}

/* Filters */
.f {
    &-primary {
        filter: invert(89%) sepia(3%) saturate(4976%) hue-rotate(98deg) brightness(102%) contrast(101%);
    }
}

/* Elements */

h1, h2, h3 {
    color: color(theme-fourth);
    body.dark-mode & {
        color: color(theme-primary);
    }
}

h4, h5, h6 {
    color: color(theme-fourth);
    body.dark-mode & {
        color: color(theme-primary);
    }
}

a {
    color: color(theme-fourth);
    &:hover {
        color: color(mono-black);
    }
    body.dark-mode & {
        color: color(theme-primary);
    }
}

p,
ul {
    .post-body &,
    .post-body-content {
        a {
            color: color(theme-fourth);
            border-bottom: 1px solid color(mono-darkest);
            &:hover {
                color: color(mono-darkest);
                border-bottom: 1px solid color(mono-darkest);
            }
            body.dark-mode & {
                color: color(mono-white);
                border-bottom: 1px solid color(theme-primary);
                &:hover {
                    color: color(mono-white);
                    border-bottom: 1px solid color(mono-white);
                }
            }
        }
    }
}

.post-body {
    a {
        &:hover {
            color: color(mono-darkest);
            body.dark-mode & {
                color: color(mono-white);
            }
        }
    }
}